/**
 * common.js
 * 
 * @author gwd
 */
var getLocation = {
	// 浏览器原生获取经纬度方法
	latAndLon : function(callback, error) {
		var that = this;
		if (navigator.geolocation) {
			navigator.geolocation.getCurrentPosition(function(position) {
				var latitude = position.coords.latitude;
				var longitude = position.coords.longitude;
				localStorage.setItem("latitude", latitude);
				localStorage.setItem("longitude", longitude);
				var data = {
					latitude : latitude,
					longitude : longitude
				};
				if (typeof callback == "function") {
					callback(data);
				}
			}, function() {
				if (typeof error == "function") {
					error();
				}
			});
		} else {
			if (typeof error == "function") {
				error();
			}
		}
	},

	// 微信JS-SDK获取经纬度方法
	weichatLatAndLon : function(callback, error) {
		var that = this;
		var timestamp = new Date().getTime() + "";
		timestamp = timestamp.substring(0, 10);
		var ranStr = randomString();

		// 微信接口配置
		wx.config({
			debug : false, // 开启调试模式,调用的所有api的返回值会在客户端alert出来，若要查看传入的参数，可以在pc端打开，参数信息会通过log打出，仅在pc端时才会打印。
			appId : 'wxbdd3ed22aa925ba7', // 必填，公众号的唯一标识
			timestamp : timestamp, // 必填，生成签名的时间戳
			nonceStr : ranStr, // 必填，生成签名的随机串
			signature : 'XXXXXXXXXXXXXXXXX',// 必填，签名，见附录1
			jsApiList : [ 'checkJsApi', 'getLocation' ]
		// 必填，需要使用的JS接口列表，所有JS接口列表见附录2
		});

		// 参见微信JS SDK文档：http://mp.weixin.qq.com/wiki/7/aaa137b55fb2e0456bf8dd9148dd613f.html
		wx.ready(function() {

			wx.getLocation({
				success : function(res) {
					var latitude = res.latitude; // 纬度，浮点数，范围为90 ~ -90
					var longitude = res.longitude; // 经度，浮点数，范围为180 ~ -180。
					var speed = res.speed; // 速度，以米/每秒计
					var accuracy = res.accuracy; // 位置精度
					localStorage.setItem("latitude", latitude);
					localStorage.setItem("longitude", longitude);
					var data = {
						latitude : latitude,
						longitude : longitude
					};
					if (typeof callback == "function") {
						callback(data);
					}
				},
				cancel : function() {
					// 这个地方是用户拒绝获取地理位置
					if (typeof error == "function") {
						error();
					}
				}
			});

		});
		wx.error(function(res) {
			if (typeof error == "function") {
				error();
			}
		});
	},
	// 将经纬度转换成城市名和街道地址，参见百度地图接口文档：http://developer.baidu.com/map/index.php?title=webapi/guide/webservice-geocoding
	cityname : function(latitude, longitude, callback) {
		$.ajax({
			url : 'http://api.map.baidu.com/geocoder/v2/?ak=btsVVWf0TM1zUBEbzFz6QqWF&callback=renderReverse&location=' + latitude + ',' + longitude + '&output=json&pois=1',
			type : "get",
			dataType : "jsonp",
			jsonp : "callback",
			success : function(data) {
				console.log(data);
				var province = data.result.addressComponent.province;
				var cityname = (data.result.addressComponent.city);
				var district = data.result.addressComponent.district;
				var street = data.result.addressComponent.street;
				var street_number = data.result.addressComponent.street_number;
				var formatted_address = data.result.formatted_address;
				localStorage.setItem("province", province);
				localStorage.setItem("cityname", cityname);
				localStorage.setItem("district", district);
				localStorage.setItem("street", street);
				localStorage.setItem("street_number", street_number);
				localStorage.setItem("formatted_address", formatted_address);
				// domTempe(cityname,latitude,longitude);
				var data = {
					latitude : latitude,
					longitude : longitude,
					cityname : cityname
				};
				if (typeof callback == "function") {
					callback(data);
				}

			}
		});
	},
	// 设置默认城市
	setDefaultCity : function(callback) {
		alert("获取地理位置失败！");
		// 默认经纬度
		var latitude = "31.337882";
		var longitude = "120.616634";
		var cityname = "苏州市";
		localStorage.setItem("latitude", latitude);
		localStorage.setItem("longitude", longitude);
		localStorage.setItem("cityname", cityname);
		localStorage.setItem("province", "江苏省");
		localStorage.setItem("district", "虎丘区");
		localStorage.setItem("street", "珠江路");
		localStorage.setItem("street_number", "88号");
		localStorage.setItem("formatted_address", "江苏省苏州市虎丘区珠江路88号");
		var data = {
			latitude : latitude,
			longitude : longitude,
			cityname : cityname
		};
		if (typeof callback == "function") {
			callback(data);
		}
	},
	// 更新地理位置
	refresh : function(callback) {
		var that = this;
		// 重新获取经纬度和城市街道并设置到localStorage
		that.latAndLon(function(data) {
			that.cityname(data.latitude, data.longitude, function(datas) {
				if (typeof callback == "function") {
					callback();
				}
			});
		}, function() {
			that.setDefaultCity(function() {
				if (typeof callback == "function") {
					callback();
				}
			});
		});
	}
};

//var d = new DateTime(2013,4,25);
//d.addDays(10);
function DateTime(year, month, date) {
  this._date = new Date();
  this._date.setFullYear(year);
  this._date.setMonth(month - 1);
  this._date.setDate(date);

  this.Year = year;
  this.Month = month;
  this.Date = date;
}
//DateTime.prototype={}
DateTime.prototype.addDays = function (days) {
  var date = new Date();
  var milliseconds = this._date.getTime() + days * 24 * 60 * 60 * 1000;
  date.setTime(milliseconds);

  return new DateTime(date.getFullYear(), date.getMonth() + 1, date.getDate());
}

DateTime.prototype.prevMonth = function () {

  var year = this._date.getFullYear();
  var month = this._date.getMonth();
  var date = new Date();
  if (month > 0) {
      date.setFullYear(year);
      date.setMonth(month - 1);
  } else {
      date.setFullYear(year - 1);
      date.setMonth(11);
  }

  return new DateTime(date.getFullYear(), date.getMonth() + 1, date.getDate());
}

DateTime.prototype.nextMonth = function () {
  var year = this._date.getFullYear();
  var month = this._date.getMonth();
  var date = new Date();
  if (month < 11) {
      date.setFullYear(year);
      date.setMonth(month + 1);
  } else {
      date.setFullYear(year + 1);
      date.setMonth(0);
  }

  return new DateTime(date.getFullYear(), date.getMonth() + 1, date.getDate());
}

DateTime.prototype.daysInMonth = function () {
  return DateTime.DaysInMonth(this.Year, this.Month);
}
DateTime._now = new Date();
DateTime.Now = new DateTime(DateTime._now.getFullYear(), DateTime._now.getMonth() + 1, DateTime._now.getDate());
DateTime.DaysInMonth = function (year, month) {
  var days = [
      [1, 31],
      [3, 31],
      [4, 30],
      [5, 31],
      [6, 30],
      [7, 31],
      [8, 31],
      [9, 30],
      [10, 31],
      [11, 30],
      [12, 31]
  ];

  if (year % 4 == 0) {
      days.push([2, 29]);
  } else {
      days.push([2, 28]);
  }

  for (var i = 0; i < days.length; i++) {
      if (month == days[i][0]) {
          return days[i][1];
      }
  }
}